
Katello - Bug #6082

registering a client without passing env and org raises undefined method error

06/05/2014 06:49 PM - Eric Helms

Status: Closed   

Priority: Normal   

Assignee: Eric Helms   

Category: Client/Agent   

Target version: Katello 2.0   

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases:  

Bugzilla link: 1096068 Red Hat JIRA:  

Pull request:    

Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1096068

Description of problem:

was trying to register a client via subscription-manager and got following error:

[root@scroponok yum.repos.d]# subscription-manager register --username admin --password changeme

undefined method `default_environment' for nil:NilClass

Version-Release number of selected component (if applicable):

Satellite 6 Beta Snap 4

Satellite-6.0.3-RHEL-6-20140508.1

on client: ==========

subscription-manager-1.9.11-1.el6.x86_64

katello-agent-1.5.3-1.el6sat.noarch

onserver:

apr-util-ldap-1.3.9-3.el6_0.1.x86_64

candlepin-0.9.7-1.el6_5.noarch

candlepin-scl-1-5.el6_4.noarch

candlepin-scl-quartz-2.1.5-5.el6_4.noarch

candlepin-scl-rhino-1.7R3-1.el6_4.noarch

candlepin-scl-runtime-1-5.el6_4.noarch

candlepin-selinux-0.9.7-1.el6_5.noarch

candlepin-tomcat6-0.9.7-1.el6_5.noarch

elasticsearch-0.90.10-4.el6sat.noarch

foreman-1.6.0.7-1.el6sat.noarch

foreman-compute-1.6.0.7-1.el6sat.noarch

foreman-gce-1.6.0.7-1.el6sat.noarch

foreman-libvirt-1.6.0.7-1.el6sat.noarch

foreman-ovirt-1.6.0.7-1.el6sat.noarch

foreman-postgresql-1.6.0.7-1.el6sat.noarch

foreman-proxy-1.6.0.4-1.el6sat.noarch

foreman-release-1.6.0-0.develop.201405061106gitfdc476d.el6.noarch

foreman-selinux-1.5.0-0.develop.el6sat.noarch

foreman-vmware-1.6.0.7-1.el6sat.noarch

katello-1.5.0-22.el6sat.noarch

katello-ca-1.0-1.noarch

katello-certs-tools-1.5.5-1.el6sat.noarch

katello-installer-0.0.37-1.el6sat.noarch

openldap-2.4.23-32.el6_4.1.x86_64

pulp-katello-plugins-0.2-1.el6sat.noarch

pulp-nodes-common-2.3.1-0.4.beta.el6sat.noarch

pulp-nodes-parent-2.3.1-0.4.beta.el6sat.noarch

pulp-puppet-plugins-2.3.1-0.4.beta.el6sat.noarch
pulp-rpm-plugins-2.3.1-0.4.beta.el6sat.noarch

pulp-selinux-2.3.1-0.4.beta.el6sat.noarch

pulp-server-2.3.1-0.4.beta.el6sat.noarch

python-ldap-2.3.10-1.el6.x86_64

ruby193-rubygem-ldap_fluff-0.2.2-2.el6sat.noarch

ruby193-rubygem-net-ldap-0.3.1-3.el6sat.noarch

ruby193-rubygem-runcible-1.0.8-1.el6sat.noarch

rubygem-hammer_cli-0.1.0-12.el6sat.noarch

rubygem-hammer_cli_foreman-0.1.0-12.el6sat.noarch

rubygem-hammer_cli_foreman_tasks-0.0.2-5.el6sat.noarch

rubygem-hammer_cli_katello-0.0.3-22.el6sat.noarch

How reproducible:

always

Steps to Reproduce:

1. install following package on client.. pull it from server

katello-ca-consumer-dhcp201-122.englab.pnq.redhat.com-1.0-1.noarch

2. install katello agent

3. register client with subscription-manager

Actual results:

undefined method `default_environment' for nil:NilClass

Expected results:

user should get proper error message if org and env is required for registeration

Additional info:

please see the production.log in attachment

rhsm.log: ====

2014-05-09 13:18:53,466 [ERROR]  @managercli.py:1059 - undefined method `default_environment' for nil:NilClass

Traceback (most recent call last):

File "/usr/share/rhsm/subscription_manager/managercli.py", line 1054, in _do_command

installed_products=self.installed_mgr.format_for_server())

File "/usr/lib64/python2.6/site-packages/rhsm/connection.py", line 722, in registerConsumer

return self.conn.request_post(url, params)

File "/usr/lib64/python2.6/site-packages/rhsm/connection.py", line 544, in request_post

return self._request("POST", method, params)

File "/usr/lib64/python2.6/site-packages/rhsm/connection.py", line 469, in _request

self.validateResponse(result, request_type, handler)

File "/usr/lib64/python2.6/site-packages/rhsm/connection.py", line 511, in validateResponse

raise RestlibException(response['status'], error_msg)

RestlibException: undefined method `default_environment' for nil:NilClass

Related issues:

Has duplicate Katello - Bug #5625: undefined method `default_environment' for... Duplicate 05/07/2014

Associated revisions

Revision 71400565 - 06/06/2014 06:52 PM - Eric Helms

Fixes #6080, #6081, #6082: Fixing registration including adding back default organization.

Addresses the following BZs: BZ1103020, BZ1095925, BZ1096068

Addresses a number of issues that have crept up recently with registration

and attempts to support the following:

1. User specifies an organization.    * User must belong to the organization    * The consumer will register to the Library of that organization.

2. User does not specify an organization.    * User must have a default organization set.    * The consumer will register to the Library of the users

default

organization.

3. User specifies an organization and an environment.     * The user must belong to the organization     * The user must have view on the environment

* The user must have create on content hosts in that organization
Revision cdaede5e - 06/09/2014 10:41 PM - Eric Helms

Merge pull request #4223 from ehelms/fixes-6080

Fixes #6080, #6081, #6082: Fixing registration including adding back def...

History

#1 - 06/05/2014 06:51 PM - Eric Helms

- Category set to Client/Agent

- Target version set to 45

- Triaged set to Yes

#2 - 06/05/2014 06:56 PM - Eric Helms

- Has duplicate Bug #5625: undefined method `default_environment' for nil:NilClass when creating a system(content host) where environment other

than Library is created and a content view is created added

#3 - 06/09/2014 10:52 PM - Eric Helms

- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset katello|commit:714005658410dbc66c78c12901f20a2510c9200b.

#4 - 08/22/2014 08:32 AM - Eric Helms

- translation missing: en.field_release set to 13
